<template>
  <a-modal
    :title="modalTitle"
    :width="1000"
    :visible="visible"
    :confirmLoading="confirmLoading"
    v-drag-modal
    class="ant-modal2"
    @cancel="handleCancel"
  >
    <a-card :bordered="false">
      <div class="table-page-search-wrapper">
        <a-form layout="inline">
          <a-row :gutter="48">
            <a-col :md="8" :sm="24">
              <a-form-item label="类型">
                <a-tree-select
                  style="width: 100%"
                  :dropdownStyle="{ maxHeight: '400px', overflow: 'auto' }"
                  :treeData="spareTypeTreeData"
                  :treeNodeFilterProp="'title'"
                  :showSearch="true"
                  v-model="queryParam.type"
                  placeholder="请选择"
                >
                </a-tree-select>
              </a-form-item>
            </a-col>
            <a-col :md="8" :sm="24">
              <a-form-item label="关键字">
                <a-input v-model="queryParam.keyword" placeholder="请输入名称/编号"/>
              </a-form-item>
            </a-col>
            <a-col :md="8 || 24" :sm="24">
              <span class="table-page-search-submitButtons">
                <a-button type="primary" @click="$refs.table.refresh(true)">查询</a-button>
                <a-button style="margin-left: 8px" @click="resetSearchForm">重置</a-button>
              </span>
            </a-col>
          </a-row>
        </a-form>
      </div>

      <div class="table-operator">
      </div>

      <s-table
        ref="table"
        size="small"
        rowKey="id"
        :columns="columns"
        :data="loadData"
        :scroll="{x: 1, y: BaseTool.Constant.scrollY }"
        :alert="options.alert"
        :customRow="options.customRow"
        :rowSelection="options.rowSelection"
        showPagination="auto"
      >
      </s-table>
      <detail ref="detailModal"/>
    </a-card>
    <template slot="footer">
      <a-button :loading="confirmLoading" type="primary" @click="handleCancel()">取消</a-button>
      <a-button :loading="confirmLoading" type="primary" @click="handleSelect()">确定</a-button>
    </template>
  </a-modal>
</template>

<script>
import { STable, Ellipsis } from '@/components'
import Detail from './Detail'
import { getPurchasePlanListPage, fetchPurchasePlanList } from '@/api/purchase/purchase-plan-list'
import { fetchSpareTypeTree } from '@/api/sqarepartmanage/sparetype'
export default {
  name: 'PurchasePlanListSelectModal',
  components: {
    STable,
    Ellipsis,
    Detail
  },
  props: {
    type: {
      type: String,
      default: 'radio'
    },
    selectedRowKey: {
      type: Array,
      default: () => {
        return []
      }
    },
    selectedRow: {
      type: Array,
      default: () => {
        return []
      }
    }
  },
  data () {
    return {
      confirmLoading: false,
      mdl: {},
      spareTypeTreeData: [],
      modalTitle: null,
      visible: false,
      record: null,
      // 查询参数
      queryParam: {
      },
      extraQueryParam: {
      },
      // 表头
      columns: [
        {
          title: '序号',
          dataIndex: 'index',
          width: 70,
          customRender: (text, record, index) => {
            return `${(this.$refs.table.localPagination.current - 1) * this.$refs.table.localPagination.pageSize + index + 1}`
          }
        },
        {
          title: '编号',
          dataIndex: 'no',
          checked: true,
          width: 180
        },
        {
          title: '名称',
          dataIndex: 'name',
          checked: true,
          width: 120
        },
        {
          title: '规格',
          dataIndex: 'specs',
          checked: true,
          width: 90
        },
        {
          title: '单位',
          dataIndex: 'unit',
          checked: true,
          width: 90
        },
        {
          title: '单价',
          dataIndex: 'price',
          checked: true,
          width: 100,
          customRender: (text, record, index) => {
            return this.BaseTool.Amount.formatter(text)
          }
        },
        {
          title: '数量',
          dataIndex: 'quantity',
          checked: true,
          width: 90,
          customRender: (text, record, index) => {
            return this.BaseTool.Amount.formatter(text)
          }
        },
        {
          title: '总价',
          dataIndex: 'totalMoney',
          checked: true,
          width: 100,
          customRender: (text, record, index) => {
            return this.BaseTool.Amount.formatter(text)
          }
        },
        {
          title: '品牌',
          dataIndex: 'brand',
          checked: true,
          width: 120
        },
        {
          title: '适用车型',
          dataIndex: 'suitableModel',
          checked: true,
          width: 120
        },
        {
          title: '车架号',
          dataIndex: 'vin',
          width: 150
        },
        {
          title: '发动机号',
          dataIndex: 'engineNum',
          width: 150
        },
        {
          title: '已购数量',
          dataIndex: 'boughtQuantity',
          width: 90,
          customRender: (text, record, index) => {
            return this.BaseTool.Amount.formatter(text)
          }
        },
        {
          title: '已到数量',
          dataIndex: 'arrivedQuantity',
          width: 90,
          customRender: (text, record, index) => {
            return this.BaseTool.Amount.formatter(text)
          }
        },
        {
          title: '未到数量',
          dataIndex: 'notArriveQuantity',
          width: 90,
          customRender: (text, record, index) => {
            return this.BaseTool.Amount.formatter(text)
          }
        },
        {
          title: '已用金额',
          dataIndex: 'usedMoney',
          width: 90,
          customRender: (text, record, index) => {
            return this.BaseTool.Amount.formatter(text)
          }
        },
        {
          title: '产地',
          dataIndex: 'producePlace',
          width: 90,
          customRender: (text, record, index) => {
            return this.BaseTool.Table.getMapText(this.areaMap, text)
          }
        },
        {
          title: '重量',
          dataIndex: 'weight',
          width: 90,
          customRender: (text, record, index) => {
            return this.BaseTool.Amount.formatter(text)
          }
        },
        {
          title: '体积',
          dataIndex: 'volume',
          width: 90,
          customRender: (text, record, index) => {
            return this.BaseTool.Amount.formatter(text)
          }
        },
        {
          title: '外形尺寸',
          dataIndex: 'dimension',
          width: 90
        },
        {
          title: '备注',
          dataIndex: 'remark',
          width: 90
        }
      ],
      // 下拉框map
      unitMap: {},
      areaMap: {},
      statusMap: {},
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        parameter = {
          ...parameter,
          ...this.queryParam,
          ...this.extraQueryParam,
          dataScope: {
            sortBy: 'desc',
            sortName: 'update_time'
          }
        }
        return getPurchasePlanListPage(Object.assign(parameter, this.queryParam))
          .then(res => {
            return res.data
          })
      },
      selectedRowKeys: [],
      selectedRows: [],

      options: {
        alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
        rowSelection: {
          selectedRowKeys: this.selectedRowKeys,
          onChange: this.onSelectChange
        }
      },
      optionAlertShow: false,
      isCreated: false
    }
  },
  created () {
    // 下拉框map
    this.unitMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.SBINFO_UNIT)
    this.areaMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.PRODUCER_AREA)
  },
  methods: {
    tableOption () {
      this.setTree()
      if (!this.optionAlertShow) {
        this.options = {
          alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
          rowSelection: {
            selectedRowKeys: this.selectedRowKeys,
            onChange: this.onSelectChange,
            // onSelect: this.onSelect,
            type: this.type,
            getCheckboxProps: record => ({
              props: {
                disabled: false,
                name: record.goodsId
              }
            })
          },
          customRow: (record) => {
            return {
              on: { // 事件
                click: (event) => { // 点击行
                  // 选择对象
                  this.mySelect([record.goodsId], [record])
                },
                dblclick: (event) => {
                  this.mySelect([record.goodsId], [record])
                  this.handleSelect()
                }
              }
            }
          }
        }
        this.optionAlertShow = true
      } else {
        this.options = {
          alert: false,
          rowSelection: null
        }
        this.optionAlertShow = false
      }
    },
    handleView (record) {
      fetchPurchasePlanList({ id: record.id }).then(res => {
        const modal = this.$refs.detailModal
        modal.base(res.data)
      })
    },
    handleOk () {
      this.$refs.table.refresh()
    },
    onSelectChange (selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },
    onSelect (record, selected, selectedRows) {
      if (selected) {
        this.selectedRows.push(record)
      }

      if (!selected) {
        const delIndex = this.selectedRows.findIndex(val => {
          return val.goodsId === record.goodsId
        })
        this.selectedRows.splice(delIndex, 1)
      }
    },
    resetSearchForm () {
      this.queryParam = {
        ...this.extraQueryParam
      }
      this.$refs.table.refresh(true)
    },
    base (record, queryParam = {}) {
      this.visible = true
      this.modalTitle = '选择信息'
      this.extraQueryParam = queryParam
      this.record = record
      if (this.isCreated) {
        this.$refs.table.clearSelected()
        this.options.rowSelection.type = this.type
        this.handleOk()
      } else {
        this.tableOption()
        this.isCreated = true
      }
      const checkedRows = this.$store.getters.checkedRows
      const checkedRowKeys = checkedRows.map((item) => {
        return item.goodsId
      })
      this.$nextTick(() => {
        this.mySelect(checkedRowKeys, checkedRows)
      })
    },
    handleCancel () {
      this.visible = false
      this.confirmLoading = false
    },
    handleSelect () {
      if (this.selectedRowKeys.length === 0) {
        this.$message.warn('请至少选择一项信息')
      } else {
        this.confirmLoading = true
        this.$emit('selected', this.record, this.selectedRowKeys, this.selectedRows)
        this.confirmLoading = false
        this.visible = false
      }
    },
    mySelect (selectedRowKeys, selectedRows) {
      if (this.type === 'radio') {
        this.$refs.table.updateSelect(selectedRowKeys, selectedRows)
        this.$refs.table.rowSelection.onChange(selectedRowKeys, selectedRows)
      } else {
        let mySelectedRowKeys
        let mySelectedRows = this.selectedRows.filter(item => item.goodsId !== selectedRowKeys[0])
        if (this.selectedRowKeys.includes(selectedRowKeys[0])) {
          mySelectedRowKeys = this.selectedRowKeys.filter(item => item !== selectedRowKeys[0])
        } else {
          mySelectedRowKeys = [...selectedRowKeys, ...this.selectedRowKeys]
          mySelectedRows = [...mySelectedRows, ...selectedRows]
        }
        this.$refs.table.updateSelect(mySelectedRowKeys, mySelectedRows)
        this.$refs.table.rowSelection.onChange(mySelectedRowKeys, mySelectedRows)
      }
    },
    /**
     * 设置备件类别树
     */
    setTree (record = {}) {
      fetchSpareTypeTree({}).then(res => {
        this.spareTypeTreeData = res.data
      })
    }
  }
}
</script>
